/***********************************************************************
 * 
 *  Copyright (C) 2005-2006 Novell, Inc. All Rights Reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; version 2.1
 *  of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, Novell, Inc.
 * 
 *  To contact Novell about this file by physical or electronic mail, 
 *  you may find current contact information at www.novell.com.
 * 
 ***********************************************************************/



#ifndef _MICASA_TYPES_H_
#define _MICASA_TYPES_H_


#if defined(WIN32)

#include <stdio.h>

   #define SSCS_CALL                            __stdcall
   #define SSCS_GLOBAL_LIBCALL_PTR(RET)         RET * __stdcall
   #define SSCS_GLOBAL_LIBCALL(RET)             RET   __stdcall 
   #define SSCS_EXTERN_LIBCALL_PTR(RET)         extern RET * __stdcall
   #define SSCS_EXTERN_LIBCALL(RET)             extern RET __stdcall
   #define SSCS_TYPEDEF_LIBCALL_PTR(RET, PTR)   typedef RET * (__stdcall *PTR)
   #define SSCS_TYPEDEF_LIBCALL(RET, PTR)       typedef RET (__stdcall *PTR)

   typedef unsigned __int64   uint64_t; 
   typedef signed __int64     int64_t;
   typedef unsigned int       uint32_t;
   typedef signed int         int32_t;
   typedef unsigned short     uint16_t;
   typedef signed short       int16_t;
   typedef unsigned char      uint8_t;
   typedef signed char        int8_t;

#else

#include <stdio.h>
#include <stdint.h>

   #define SSCS_CALL
   #define SSCS_GLOBAL_LIBCALL_PTR(RET)         RET *
   #define SSCS_GLOBAL_LIBCALL(RET)             RET
   #define SSCS_EXTERN_LIBCALL_PTR(RET)         extern RET *
   #define SSCS_EXTERN_LIBCALL(RET)             extern RET
   #define SSCS_TYPEDEF_LIBCALL_PTR(RET, PTR)   typedef RET * (*PTR)
   #define SSCS_TYPEDEF_LIBCALL(RET, PTR)       typedef RET (*PTR)

#endif // if defined(WIN32)

//
// Defines to make API descriptions more readable
//
#ifndef IN
   #define IN
#endif

#ifndef OUT
   #define OUT
#endif

#ifndef INOUT
   #define INOUT
#endif


#endif   // ifndef _MICASA_TYPES_H_
